
*what do our results predict for changes in presidential election outcomes by state pre to post?
/

clear
clear matrix
clear mata
set more off
set maxvar 32000


*election outcomes and cps turnout
* cqelection_cps_merged (these files are not included but do file with the same is included)

*prediction:
use "$input/prediction_st_elex_yr_cells"

rename elex_yr year
rename predict_2p_st_yr pred_white_vote
rename predict_2p_cf_st_yr cf_white_vote
rename predict_2p_cf_pool_post_st_yr cf_post_white_vote
rename predict_2p_cf_pool_pre_st_yr cf_pre_white_vote
rename predict_2p_pre_st_yr pred_preprz_white_vote

drop act_st_yr noprez_st_yr count_st_yr 


reshape wide pred* cf*, i(state) j(year)
forvalues X= 1956(4)1980{
label var pred_white_vote`X' "Predicted White Vote `X'"
label var pred_preprz_white_vote`X' "Predicted White Vote `X' Pre Period Blk Prz"
label var cf_white_vote`X' "Counterfactual White Vote `x'"
label var cf_post_white_vote`X' "Counterfactual White Vote pooling post-years"ff
label var cf_pre_white_vote`X' "Counterfactual White Vote pooling pre-years"
}


*state codes here are unique, so do abbrevation so can merge
gen state_a=""
replace state_a="ME" if state==11
replace state_a="NH" if state==12
replace state_a="VT" if state==13
replace state_a="MA" if state==14
replace state_a="RI" if state==15
replace state_a="CT" if state==16
replace state_a="NY" if state==21
replace state_a="NJ" if state==22
replace state_a="PA" if state==23
replace state_a="MD" if state==24
replace state_a="DE" if state==25
replace state_a="WV" if state==26
replace state_a="DC" if state==27
replace state_a="OH" if state==31
replace state_a="MI" if state==32
replace state_a="IN" if state==33
replace state_a="IL" if state==34
replace state_a="WI" if state==41
replace state_a="MN" if state==42
replace state_a="IA" if state==43
replace state_a="MO" if state==44
replace state_a="ND" if state==45
replace state_a="SD" if state==46
replace state_a="NE" if state==47
replace state_a="KS" if state==48
replace state_a="VA" if state==51
replace state_a="NC" if state==52
replace state_a="SC" if state==53
replace state_a="GA" if state==54
replace state_a="FL" if state==55
replace state_a="KY" if state==56
replace state_a="TN" if state==57
replace state_a="AL" if state==58
replace state_a="MS" if state==59
replace state_a="AR" if state==61
replace state_a="LA" if state==62
replace state_a="OK" if state==63
replace state_a="TX" if state==64
replace state_a="MT" if state==71
replace state_a="AZ" if state==72
replace state_a="CO" if state==73
replace state_a="ID" if state==74
replace state_a="WY" if state==75
replace state_a="UT" if state==76
replace state_a="NV" if state==77
replace state_a="NM" if state==78
replace state_a="CA" if state==81
replace state_a="OR" if state==82
replace state_a="WA" if state==83
replace state_a="HI" if state==84
replace state_a="AK" if state==85

rename state state_g
label var state_g "Gallup state codes"

gen south =1 if state_a=="AL" | state_a=="AR" | state_a=="FL" | state_a=="GA" | state_a=="LA" | state_a =="MS" | state_a=="NC" | state_a=="SC" | state_a=="TN" | state_a=="TX" | state_a=="VA"
replace south =0 if south ==. & state_a~=""
sort south
save predtemp, replace


*ANES
use "$path/Input/Anes/ANES_descV1.dta", clear 
*match years to gallup
keep if year>=1956 & year<=1980

gen south =1 if state_a=="AL" | state_a=="AR" | state_a=="FL" | state_a=="GA" | state_a=="LA" | state_a =="MS" | state_a=="NC" | state_a=="SC" | state_a=="TN" | state_a=="TX" | state_a=="VA"
replace south =0 if south ==. & state_a~=""
keep if mod(year,4)==0

gen post = 1 if year>=1964 & year~=.
replace post =0 if post==. & year~=.

*dem presidential vote, if turned out for one of two major parties 
gen demprezvote =1 if prezvote==1
replace demprezvote=0 if prezvote==2 

*need to capture non white vote, obviously can't do by state let's try region
bysort south year: count if demprezvote~=. & race~=1
*by year cells aren't terrible, lowest 72 or after is 56, so may not want to rely on year to year variation
bysort south post: count if demprezvote~=. & race~=1

*make versions using year to year and using just pre post keep the N
preserve
keep if race~=1 & race~=.
collapse (mean) nwdemprezvote=demprezvote  [pw=wgt], by(south year)
reshape wide nwdemprezvote , i(south) j(year)
forvalues X= 1956(4)1980{
label var nwdemprezvote`X' "Non white Democratic Presidential Vote `X'"
}
sort south
save stemp1, replace

restore
preserve
keep if race~=1 & race~=.
collapse (count) nwdemprezvoteN=demprezvote , by(south year)
reshape wide nwdemprezvoteN , i(south) j(year)
forvalues X= 1956(4)1980{
label var nwdemprezvoteN`X' "Cell count: Non white Democratic Presidential Vote `X'"
}
sort south
save stemp2, replace



restore
*before we do averages across years, drop 1968 because more than two parties
drop if year==1968


preserve
keep if race~=1 & race~=.
collapse (mean) nwdemprezvote=demprezvote, by(south post)
reshape wide nwdemprezvote, i(south) j(post)
label var nwdemprezvote0 "Non white Democratic Presidential in Pre Period"
label var nwdemprezvote1 "Non white Democratic Presidential in post period"
sort south
save stemp3, replace
restore

keep if race~=1 & race~=.
collapse (count) nwdemprezvoteN=demprezvote, by(south post)
reshape wide nwdemprezvoteN, i(south) j(post)
label var nwdemprezvoteN0 "Cell count: Non white Democratic presidential Vote in Pre Period"
label var nwdemprezvoteN1 "Cell count: Non white Democratic presidential vote in post period"

sort south 
merge south using stemp3
tab _merge
drop _merge
sort south
merge south using stemp2
tab _merge
drop _merge
sort south
merge south using stemp1
tab _merge
drop _merge

save nwvotetemp, replace
erase stemp3.dta
erase stemp2.dta
erase stemp1.dta

*merge everything together
sort south
merge south using predtemp
tab _merge
drop _merge
sort state_a
merge state_a using cqelections/cqelection_cps_merged
tab _merge
drop if _merge==2
drop if state_a=="DC" | state_a=="HI" | state_a=="AK"

*create turnout variable that averages across years
egen turnout_white1 = rowmean(turnout_white1972 turnout_white1976 turnout_white1980)
label var turnout_white1 "CPS: average white share of turnout in post-period"

*create demshare of two party vote
forvalues X= 1952(4)1980{
gen demsh2party`X' = demvotes`X' / (demvotes`X'+repvotes`X')
label var demsh2party`X' "Democratic share of two party vote in `X'" 
}

*average 1952 and 1956
gen demsh2party5256 = (demsh2party1952 + demsh2party1956)/2
label var demsh2party5256 "Dems share of 2 party vote avg of 1952 and 1956"

label data "Simulation Data"
saveold simdata, replace

erase nwvotetemp.dta
erase predtemp.dta


local f=1972
while `f'<=1980{
*allow turnout to vary by year (0) or just use post-average (1)
local y=0
while `y'<=1{
*allow non white pres vote to vary by year (0) or just use post-average (1)
local z=0
while `z'<=1{

clear
use simdata

*actual change in votes
gen demvoteschange5256`f' =(demsh2party`f' - demsh2party5256)
label var demvoteschange5256`f' "Change in democratic presidential vote from 52/56 to `f'"

*actual change in rank
gsort- demsh2party5256
gen rank1 = _n
gsort- demsh2party`f'
gen rank2 = _n
gen chrank = rank1-rank2
gen whshturnout = turnout_white`f'*(1-`y') + turnout_white1*`y'
replace whshturnout = turnout_white1 if whshturnout==.
gen nwdemprezvote =  nwdemprezvote`f'*(1-`z') + nwdemprezvote1*`z'
gen preddem = pred_white_vote`f'*whshturnout + nwdemprezvote*(1-whshturnout)
*without triple difference
gen preddemn3 = cf_white_vote`f'*whshturnout + nwdemprezvote*(1-whshturnout)
*using pre period black prez
gen preddempbp=pred_preprz_white_vote`f'*whshturnout + nwdemprezvote*(1-whshturnout)
gen predemchange`f' = preddem - demsh2party5256
gen predemchangen3`f' = preddemn3 - demsh2party5256
gen predemchangepbp`f' = preddempbp - demsh2party5256
gen shchange = predemchange`f'/demvoteschange5256`f'
gen shchangen3 = predemchangen3`f'/demvoteschange5256`f'
gen shchangepbp = predemchangepbp`f'/demvoteschange5256`f'

*sum changes by region
egen spredemchange= total( predemchange`f'), by (south)
egen spredemchangen3 = total(predemchangen3`f'), by(south)
egen spredemchangepbp = total(predemchangepbp`f'), by (south)
egen sdemvoteschange5256`f' = total(demvoteschange5256`f'), by(south)
label var spredemchange "Sum of predicted change within region"
label var spredemchangen3 "Sum of predicted change, no 3int, within region"
label var spredemchangepbp "Sum of predicted change, pre per blk prez, within region"
label var sdemvoteschange5256`f' "Sum of change 5256 to `f', within region"

*share of regional change
gen shrchange = spredemchange/sdemvoteschange5256`f'
gen shrchangen3 = spredemchangen3/sdemvoteschange5256`f'
gen shrchangepbp = spredemchangepbp/sdemvoteschange5256`f'
label var shrchange "Share of reg sum of change explained"
label var shrchangen3 "Share of reg sum of change explained, no 3 int"
label var shrchangepbp "Share of reg sum of change, pre per blk prez"

*can we predict change in rank
*sticking to comparison to truth
gsort- preddem
gen prank = _n if preddem~=.
gen pchrank = rank1-prank

gsort- preddemn3 
gen prankn3 = _n if preddemn3~=.
gen pchrankn3 = rank1-prankn3

gsort- preddempbp
gen prankpbp = _n if preddempbp~=.
gen pchrankpbp = rank1-prankpbp

label var preddem "Predicted share of votes to Democrats"
label var preddemn3 "Predicted share of votes to Democrats w/o triple int"
label var preddempbp"Predicted share of votes to Democrats pre period blk prz"
label var shchange "Share of actual change prediction  explains"
label var shchangen3 "Share of actual change prediction explain wo triple int"
label var shchangepbp "Share of actual change prediction explain pre period blk prz"
label var prank "State Dem vote share rank in counterfactual"
label var prankn3 "State Dem vote share rank in counterfactual wo triple int"
label var prankpbp "State Dem vote share rank in counterfactual wo triple int"
label var pchrank "Change in state predicted Dem vote share rank relative to 56 truth"
label var pchrankn3 "Change in state predicted Dem vote share rank relative to 56 truth wo triple int"
label var pchrankpbp "Change in state predicted Dem vote share rank relative to 56 truth pre period blk prz"
label var chrank "Change in state Dem vote share rank"

di "From 52/56 to `f',  turnout pooled =`y', nonwhite voteshare pooled = `z'"
bysort south: summ shchange*, detail
di "Without those with small changes"
bysort south: summ shchange* if demvoteschange5256`f'<-.01 | (demvoteschange5256`f' >.01 & demvoteschange5256`f'~=.), detail 

corr chrank pchrank
bysort south: corr chrank pchrank
corr chrank pchrankn3
bysort south: corr chrank pchrankn3
corr chrank pchrankpbp
bysort south: corr chrank pchrankpbp

label data "`f'sim, turnout pooled =`y', nonwhite pool= `z'"

keep state_a south demsh2party5256 demsh2party`f' preddem* sh*change*  pchrank* chrank predemchange*
order state_a south demsh2party5256 demsh2party`f' preddem* sh*change*  pchrank* chrank 
sort state_a
saveold $input/elecsim`f'`y'`z', replace

local z = `z'+1
}
local y = `y'+1
}
local f = `f'+4
}
*the end


foreach X in 00 01 10 11{
clear
*summing across states instead of across years
use $input/elecsim1972`X'
keep state_a south demsh2party5256 demsh2party1972 predemchange*
save temp, replace

use $input/elecsim1976`X'
keep state_a south demsh2party5256 demsh2party1976 predemchange*
save temp2, replace

use $input/elecsim1980`X'
keep state_a south demsh2party5256 demsh2party1980 predemchange*

merge 1:1 state_a using temp
tab _merge
drop _merge
merge 1:1 state_a using temp2
tab _merge
drop _merge

erase temp.dta
erase temp2.dta

gen sschange = (predemchange1972 + predemchange1976 + predemchange1980)/[(demsh2party1972 - demsh2party5256) + (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)]
replace sschange = (predemchange1976 + predemchange1980)/[ (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)] if state_a=="MS"

gen sschangen3 = (predemchangen31972 + predemchangen31976 + predemchangen31980)/[(demsh2party1972 - demsh2party5256) + (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)]
replace sschangen3 = (predemchangen31976 + predemchangen31980)/[ (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)] if state_a=="MS"

gen sschangepbp = (predemchangepbp1972 + predemchangepbp1976 + predemchangepbp1980)/[(demsh2party1972 - demsh2party5256) + (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)]
replace sschangepbp = (predemchangepbp1976 + predemchangepbp1980)/[ (demsh2party1976 - demsh2party5256) + (demsh2party1980 - demsh2party5256)] if state_a=="MS"


label var sschange "State Share across years of actual change prediction  explains"
label var sschangen3 "State Share across years of actual change prediction explain wo triple int"
label var sschangepbp "State Share across years of actual change prediction explain pre period blk prz"

keep if south==1
keep demsh2party5256 state_a sschange* 
save $input/statesim`X', replace

}

*******************************************************************************


#delimit ;



****Use crosswalk to get state names ;
use $input/state_name_ab_fips_xwalk, clear ;

rename state_ab state_a ;
sort state_a ;
tempfile xwalk ;
save `xwalk' ;

use $input/statesim00, clear ;
sort state_a ;
merge state_a using `xwalk' ;

keep if _merge==3 ;


***Use mkmat to make the table, with columns that equal the variable and rows the state name ;
***We want to display the median for each category (variable) ;
***Super clunky (must be a more elegant way to do this via esttab and esttad) ;

local postfoot_text= "\hline Median & & & \\ share predicted" ;
 
expand 2 if _n==11 ;
replace state_a="Median prediction" if _n==12 ;
foreach var of varlist sschange sschangen3 sschangepbp { ;
replace `var'=round(`var', .001) ;
replace `var'=. if _n==12 ;
sum `var', d ;
*replace `var'=round(`r(p50)', .001) if _n==12 ;
local temp=round(`r(p50)', .001) ;
local postfoot_text " `postfoot_text' & `temp'" ;
} ;

replace demsh2party=round(demsh2party, .001) ;

replace demsh2party=. if _n==12 ;

mkmat ss* demsh if _n<12, rownames(state_a)  matrix(bodie) ;

esttab matrix(bodie) $output/simulation_table.tex  , replace fragment booktabs cell(mean(fmt(a3))) 
collabels("Baseline" "South x Aft=0" "No Prez share" "1950s Dem. share", lhs("State"))
 nomtitles  postfoot(`postfoot_text' \\) ;

