**NOTE 1: for the 1971-1980 files the 
* the wgt variable which indicates times at home
*will be read in

**NOTE 2: The file naming convention remains consistent throughout this dataset, with file 1978-1101 following file 1978-0999 (file 1978-1100 is not included in our dataset, as it does not contain the party variable). Note that after file 999, however, Gallup changed its naming convention such that the subsequent file is titled 100G. At the same time, Roper retained its naming convention of year-XXXX -- with the number 1 replacing zero as the first of the four digits -- though beginning with file 1101 (and ostensibly 1100) it added a "G" to the end of the file number (e.g., file number 1978-1101G). Occasionally, though not always, the title section on the front page of the Roper-obtained codebook notes that the actual Gallup title is the three-digit code followed by "G" (see, for example, file number 1979-1127 [shows actual Gallup title of #127G] versus 1979-1128 [title section shows Roper's title, #1128G]). To avoid any confusion and to ensure consistency across surveys from different time periods, we continue to follow the naming convention of year-XXXX, with the number 1 replacing zero as the first of the four digits (e.g., file number 1978-1101).

clear
set more off
cd "/Users/`c(username)'/Dropbox/southern_strategy/Gallup&GSS/PartyFiles1971_1980"

log using Singh_1971-1980.2014.log, replace


****USAIPO1980-1166****

infile using Dictionaries\aipo1980-1166.dct

**correct N read in**1549

*Create a variable for survey code
gen svy = "1980-1166"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1166.dta, replace


*********************************************
clear

*************USAIPO1980-1165*****


infile using Dictionaries\aipo1980-1165.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1165"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1165.dta, replace

**************

clear

**************USAIPO 1980-1164***


infile using Dictionaries\aipo1980-1164.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1164"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1164.dta, replace

****************

clear

**************USAIPO 1980-1163***


infile using Dictionaries\aipo1980-1163.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1163"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1163.dta, replace

*************************
clear

*************************************************

*****USAIPO 1980-1162******

infile using Dictionaries\aipo1980-1162.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1162"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1162.dta, replace

********

clear

*****USAIPO 1980-1161********

infile using Dictionaries\aipo1980-1161.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1161"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1161.dta, replace

*******

clear

*****USAIPO 1980-1160***


infile using Dictionaries\aipo1980-1160.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1160"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**wgt 1 does not match but the rest of the frequencies add up
**checked by adding frequencies and the codebook seems to be wrong

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1160.dta, replace

***************************

clear

******USAIPO**1980-1159****

infile using Dictionaries\aipo1980-1159.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1159"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1159.dta, replace

**********************

clear

***********USAIPO 1980-1158****

infile using Dictionaries\aipo1980-1158.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1158"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

***cannot see the weight variable in the codebook: searched using
*times at home as well. 

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*cannot see if frequency matches since it is not in the codebook,
*but based on other surveys the distribution makes sense. 

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1158.dta, replace

*************
clear

***********USAIPO 1980-1157***

infile using Dictionaries\aipo1980-1157.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1157"

*Create a variable for survey year
gen svy_year = 1980

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**weight does not look like it is in the codebook but the 
*N matches the # on the second page of the codebook

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig
**frequencies of age are not in the codebook but the 
*dsitribution makes sense
gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1157.dta, replace

*************

clear

*****USAIPO**1980-1156****

infile using Dictionaries\aipo1980-1156.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1156"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "May-June"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1980-1156.dta, replace

*******
clear

***************USAIPO 1980-1155****

infile using Dictionaries\aipo1980-1155.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1155"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency does not make sense with the codebook
*went back to the dictionary and checked that the column
*is correct. distribution in Stata output makes sense -- comparable to distribution of age in other surveys; in addition, the frequency of "no answer" in the actual variable (VAR 87) -- 13 -- matches Stata output rather than "no answer" in age deciles variable

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1155.dta, replace

******************
clear

******USAIPO1980-1154*****

infile using Dictionaries\aipo1980-1154.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1154"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1154.dta, replace

******

clear

***********USAIPO 1980-1153*****

infile using Dictionaries\aipo1980-1153.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1153"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1153.dta, replace

********

clear

********USAIPO 1980-1151******

infile using Dictionaries\aipo1980-1151.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1151"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1151.dta, replace

********
clear

**************USAIPO 1980-1150***

infile using Dictionaries\aipo1980-1150.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1150"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state =0 if state==18

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1150.dta, replace

*****

clear

******USAIPO 1980-1149****

infile using Dictionaries\aipo1980-1149.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1149"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "February-March"

*Begin harmonization of variables

tab wgt

**weight distribution is read in but not in the codebook

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

**age frequencies not in codebook but the numbers add up and make sense
gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1149.dta, replace

*******

clear

**********USAIPO 1980-1148****


infile using Dictionaries\aipo1980-1148.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1148"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**weight distribution is read in, but frequencies not displayed in the codebook (i.e., could not check variable)


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig
*age frequncies not in the codebook but the distribution makes sense
*and mirrors the other surveys
gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1148.dta, replace

*******

clear

**************USAIPO 1980-1147****

infile using Dictionaries\aipo1980-1147.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1147"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1147.dta, replace

******************

clear

*******USAIPO 1980-1146*********

infile using Dictionaries\aipo1980-1146.dct

**correct N read in

*Create a variable for survey code
gen svy = "1980-1146"

*Create a variable for survey year
gen svy_year = 1980 

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

gen age = age_orig

*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data

saveold FormattedData\1980-1146.dta, replace

clear

***************************

***USAIPO 1979-1145*****

infile using Dictionaries\aipo1979-1145.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1145"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1145.dta, replace

***************************

clear

****USAIPO1979-1144********

infile using Dictionaries\aipo1979-1144.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1144"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "November-December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1144.dta, replace

**********************

clear

*************USAIPO 1979-1143*****

infile using Dictionaries\aipo1979-1143.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1143"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1143.dta, replace

**********************************

clear

**********************USAIPO 1979-1142****

infile using Dictionaries\aipo1979-1142.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1142"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1142.dta, replace

********************

clear

****************USAIPO1979-1141******

infile using Dictionaries\aipo1979-1141.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1141"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt


*tab raceSex_orig is in the codebook but the column
*location is off. only reading in race and sex 

*1 WHITE 2 BLACK 3 OTHER harmonization for race

tab race_orig

*frequency matches but columns are incorrect in the
*codebook; actually was column for sex; went back 
*and changed

gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches, but the column location in the 
*codebook is incorrect. it is actually the column for race
*so went back and changed it. matches now

gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*wrong column location in codebook: Meredith looked it up 
*and it is column 114; changed it in the dictionary

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

*this variable is actually in column 80. The codebook is wrong, but with 
*this workaround, the reading is correct

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1141.dta, replace

****************************************

clear

*****USAIPO1979-1140********

infile using Dictionaries\aipo1979-1140.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1140"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1140.dta, replace

*********************

clear


****USAIPO1979-1139****

*Read in dictionary file for USAIPO1979-1139; September 28, 1979 - October 1, 1979)
infile using Dictionaries\aipo1979-1139.dct

*The sample size in the codebook - 1,520 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1979-1139"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "September-October"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*Check the variable - tab each age category and compare with the decile age variable (VAR 60) in the codebook
*18-19 years
tab age_orig if age_orig>17 & age_orig<20
*20-29 years
tab age_orig if age_orig>19 & age_orig<30
*30-39 years
tab age_orig if age_orig>29 & age_orig<40
*40-49 years
tab age_orig if age_orig>39 & age_orig<50
*50-59 years
tab age_orig if age_orig>49 & age_orig<60
*60-69 years
tab age_orig if age_orig>59 & age_orig<70
*70-79 years
tab age_orig if age_orig>69 & age_orig<80
*80-89 years
tab age_orig if age_orig>79 & age_orig<90
*90 years and over
tab age_orig if age_orig>=90
*NO CODE OR NO DATA
tab age_orig if age_orig == 0

*The frequency distribution for this variable matches that in the codebook

*Tabulate the variable to ensure that there are no unexpected observations (i.e., outside expected age categories)
tab age_orig

*There are no unexpected observations

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Note that state likely is not shown in the correct column in the codebook; if you read in the column for state (89), there are unexpected values in the Stata output. The workaround is to use column number 90 -- rather than the indicated column number (89) -- with a width of two. If you do so, state checks out correctly.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1979-1139.dta, replace

clear


********************USAIPO 1979-1138****

infile using Dictionaries\aipo1979-1138.dct

*The sample size shown on the front page of the codebook - 1,538 - does not match the number of observations read into Stata (1,537). The total N for most (if not all) variables, however, equals the number read into Stata.

*Create a variable for survey code
gen svy = "1979-1138"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1138.dta, replace

***********************

clear

**********USAIPO1979-1137***********


infile using Dictionaries\aipo1979-1137.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1137"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1137.dta, replace

*******************************

clear

*************USAIPO 1979-1136*******

infile using Dictionaries\aipo1979-1136.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1136"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1136.dta, replace

********************

clear

***********USAIPO 1979-1135**********

infile using Dictionaries\aipo1979-1135.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1135"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1135.dta, replace


*************

clear

************USAIPO 1979-1133**********

infile using Dictionaries\aipo1979-1133.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1133"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1133.dta, replace

************************

clear

************USAIPO 1979-1132***************

infile using Dictionaries\aipo1979-1132.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1132"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "June-July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1132.dta, replace


****************

clear


****USAIPO1979-1131****

*Read in dictionary file for USAIPO1979-1131; June 22, 1979 - June 25, 1979)
infile using Dictionaries\aipo1979-1131.dct

*The sample size in the codebook - 1,571 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1979-1131"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*Check the variable - tab each age category and compare with the decile age variable (VAR 60) in the codebook
*18-19 years
tab age_orig if age_orig>17 & age_orig<20
*20-29 years
tab age_orig if age_orig>19 & age_orig<30
*30-39 years
tab age_orig if age_orig>29 & age_orig<40
*40-49 years
tab age_orig if age_orig>39 & age_orig<50
*50-59 years
tab age_orig if age_orig>49 & age_orig<60
*60-69 years
tab age_orig if age_orig>59 & age_orig<70
*70-79 years
tab age_orig if age_orig>69 & age_orig<80
*80-89 years
tab age_orig if age_orig>79 & age_orig<90
*90 years and over
tab age_orig if age_orig>=90
*NO CODE OR NO DATA
tab age_orig if age_orig == 0

*The frequency distribution for this variable matches that in the codebook

*Tabulate the variable to ensure that there are no unexpected observations (i.e., outside expected age categories)
tab age_orig

*There are no unexpected observations

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Note that state likely is not shown in the correct column in the codebook; if you read in the column for state (85), there are unexpected values in the Stata output. The workaround is to use column number 86 -- rather than the indicated column number (85) -- with a width of two. If you do so, state checks out correctly.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1979-1131.dta, replace

clear


******USAIPO 1979-1130***********

infile using Dictionaries\aipo1979-1130.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1130"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*In the codebook the column location is incorrect. to get at the
*right distributions, needed to use the region location. So used
*column 95 with a width of 2 to get at state

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1130.dta, replace

***********************


clear

**********************USAIPO 1979-1129***

infile using Dictionaries\aipo1979-1129.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1129"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1129.dta, replace

*****************8

clear

*********USAIPO 1979-1128****

infile using Dictionaries\aipo1979-1128.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1128"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1128.dta, replace

**********************

clear

***************USAIPO 1979-1127****

infile using Dictionaries\aipo1979-1127.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1127"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1127.dta, replace

************************

clear

***********USAIPO 1979-1125****************

infile using Dictionaries\aipo1979-1125.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1125"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1125.dta, replace

*************

clear

************USAIPO 1979-1124************

infile using Dictionaries\aipo1979-1124.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1124"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1124.dta, replace

***********************

clear

********************USAIPO 1979-1123***

infile using Dictionaries\aipo1979-1123.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1123"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

**STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 27 if state_orig==29

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1123.dta, replace


********************

clear

*************USAIPO 1979-1122****


infile using Dictionaries\aipo1979-1122.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1122"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1122.dta, replace

*************************

clear

***********USAIPO 1979-1120****

infile using Dictionaries\aipo1979-1120.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1120"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1120.dta, replace


************

clear

**********USAIPO 1979-1119*********

infile using Dictionaries\aipo1979-1119.dct

**correct N read in

*Create a variable for survey code
gen svy = "1979-1119"

*Create a variable for survey year
gen svy_year = 1979

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

*For this file there is a weight frequency which is 0

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*cannot say if frequency matches since it is not reported in the codebook
*but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1979-1119.dta, replace


******************


clear

***USAIPO 1978-1117*****

infile using Dictionaries\aipo1978-1117.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1117"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1117.dta, replace

***************************

clear


*****************USAIPO 1978-1116****************

infile using Dictionaries\aipo1978-1116.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1116"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

***frequency not in codebook 
*butdistribution and missig data frequency makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1116.dta, replace

**********************

clear

***********USAIPO 1987-1115*****


infile using Dictionaries\aipo1978-1115.dct

*Create a variable for survey code
gen svy = "1978-1115"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1115.dta, replace


*************************

clear

********USAIPO 1978-1114*******

infile using Dictionaries\aipo1978-1114.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1114"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1114.dta, replace


***********************

clear

*************USAIPO 1978-1113****

infile using Dictionaries\aipo1978-1113.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1113"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1113.dta, replace

*************************

clear

***********USAIPO 1978-1112*************

infile using Dictionaries\aipo1978-1112.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1112"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*State is not correct in the codebook; if you read in the column for state (35), you get only single digits. 
*There is a workaround, however: you can read in the 
*column for region with a width of two and it works 
*(with the exception of South Dakota, which is off by 2, i.e., 
*7 observations in the codebook and 5 observations in Stata; 
*there is no frequency table to examine this further). Column
*in dictionary is 34

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1112.dta, replace

*****************************

clear


*********USAIPO 1978-1111*************

infile using Dictionaries\aipo1978-1111.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1111"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1111.dta, replace

******************************8

clear

**********USAIPO 1978-1110******

infile using Dictionaries\aipo1978-1110.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1110"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1110.dta, replace


***************************

clear

****************USAIPO 1978-1109*****

infile using Dictionaries\aipo1978-1109.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1109"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1109.dta, replace


*********************

clear

*******************USAIPO 1978-1108*******

infile using Dictionaries\aipo1978-1108.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1108"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1108.dta, replace


*********************************

clear

***********USAIPO 1978-1105**************

infile using Dictionaries\aipo1978-1105.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1105"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*With the exception of one state -- California -- the frequency distribution displayed next to the variable in the codebook matches the tabulated variable. As there is no frequency table in the back of the codebook, we cannot double-check the variable by identifying frequencies by column and then comparing against the table.

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1105.dta, replace


*********************

clear

***********USAIPO 1978-1104*****

infile using Dictionaries\aipo1978-1104.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1104"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1104.dta, replace

**********************

clear

**********USAIPO 1978-1103******

infile using Dictionaries\aipo1978-1103.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1103"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Note that state likely is not shown in the correct column in the codebook; if you read in the column for state (33), there are unexpected values in the Stata output (33 appears to be a typo, as the variable for city size is also shown in 33). The workaround is to use column number 36 -- rather than the indicated column number (33) -- with a width of two. If you do so, state checks out correctly. 

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1103.dta, replace

******************

clear

***********USAIPO 1978-1102****

infile using Dictionaries\aipo1978-1102.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1102"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1102.dta, replace


************
clear

***********USAIPO 1978-1101*****

infile using Dictionaries\aipo1978-1101.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-1101"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "April-May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-1101.dta, replace


******************

clear

***********USAIPO 1978-0999****

infile using Dictionaries\aipo1978-0999.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0999"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*Note that age likely is not shown in the correct column in the codebook; if you read in the column for age (68), there are unexpected values in the Stata output (68 appears to be a typo, as the preceding variable is in 66 with a width of 1). The workaround is to use the expected column number (67) -- rather than the indicated column number (68) -- with a width of two. If you do so, age checks out correctly. 

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0999.dta, replace

*****************

clear

**********USAIPO 1978-0998*****

infile using Dictionaries\aipo1978-0998.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0998"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "March-April"

*Begin harmonization of variables

tab wgt

*weight has a 0 value and distribution not in codebook

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0998.dta, replace


***************************

clear

*************USAIPO 1978-0997*****

infile using Dictionaries\aipo1978-0997.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0997"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0997.dta, replace

**********************

clear

*********USAIPO 1978-0996****

infile using Dictionaries\aipo1978-0996.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0996"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0996.dta, replace


***********************

clear

************USAIPO 1978-0995*****

infile using Dictionaries\aipo1978-0995.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0995"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0995.dta, replace


***************************

clear

***********USAIPO 1978-0994****

infile using Dictionaries\aipo1978-0994.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0994"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0994.dta, replace

******************

clear


****USAIPO1978-0993****

*Read in dictionary file for USAIPO1978-0993; February 10, 1978 - February 13, 1978)
infile using Dictionaries\aipo1978-0993.dct

*The sample size in the codebook - 1,515 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1978-0993"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*Normally, we would compare the age frequencies by category to either the age distribution chart or the age deciles variables (depending on which version the codebook uses). However, this codebook provides neither, nor does it provide a frequency table in the back of the codebook, so we cannot double-check the variable by identifying frequencies by column and then comparing against the table.

*Perform basic check: tabulate the variable to ensure that there are no unexpected observations (i.e., outside expected age categories)
tab age_orig

*There are no unexpected observations

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1978-0993.dta, replace

clear


*************USAIPO 1978-0992*****

infile using Dictionaries\aipo1978-0992.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0992"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0992.dta, replace


***********************

clear

***********USAIPO 1978-0991*****

infile using Dictionaries\aipo1978-0991.dct

**correct N read in

*Create a variable for survey code
gen svy = "1978-0991"

*Create a variable for survey year
gen svy_year = 1978

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1978-0991.dta, replace

**************************

clear


****USAIPO 1977-0990*******

infile using Dictionaries\aipo1977-0990.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0990"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0990.dta, replace

***************************

clear

**************USAIPO 1977-0989**

infile using Dictionaries\aipo1977-0989.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0989"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0989.dta, replace

*************************

clear

**********USAIPO 1977-0988**

infile using Dictionaries\aipo1977-0988.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0988"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0988.dta, replace

***********************

clear

*******USAIPO 1977-0987****

infile using Dictionaries\aipo1977-0987.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0987"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0987.dta, replace

************************

clear

***********USAIPO1977-0986***

infile using Dictionaries\aipo1977-0986.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0986"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0986.dta, replace

********************************

clear

**********USAIPO 1977-0985***

infile using Dictionaries\aipo1977-0985.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0985"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0985.dta, replace

***********************************

clear

***********USAIPO1977-0984****

infile using Dictionaries\aipo1977-0984.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0984"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "September-October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*age distribution not in codebook, but the
*distribution that is read in makes sense 

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0984.dta, replace

********************************

clear

***********USAIPO1977-0983*****

infile using Dictionaries\aipo1977-0983.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0983"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook, but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0983.dta, replace

**********************

clear

***************USAIPO 1977-0982****

infile using Dictionaries\aipo1977-0982.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0982"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0982.dta, replace

****************************

clear

**********USAIPO 1977-0981*********

infile using Dictionaries\aipo1977-0981.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0981"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0981.dta, replace

*****************************

clear

**********USAIPO 1977-0980*****


infile using Dictionaries\aipo1977-0980.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0980"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0980.dta, replace

*************************

clear

************USAIPO 1977-0979*****

infile using Dictionaries\aipo1977-0979.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0979"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0979.dta, replace


********************************

clear

************USAIPO 1977-0978*********


infile using Dictionaries\aipo1977-0978.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0978"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0978.dta, replace

***************************************

clear

************USAIPO 1977-0977**********

infile using Dictionaries\aipo1977-0977.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0977"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0977.dta, replace

***********************

clear

****************USAIPO 1977-0976*****

infile using Dictionaries\aipo1977-0976.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0976"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0976.dta, replace

****************************

clear

************USAIPO 1977-0975******

infile using Dictionaries\aipo1977-0975.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0975"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0975.dta, replace

**********************************

clear

************USAIPO 1977-0974******

infile using Dictionaries\aipo1977-0974.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0974"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "April-May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0974.dta, replace

******************************************

clear

**************USAIPO 1977-0973********

infile using Dictionaries\aipo1977-0973.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0973"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0973.dta, replace

*********************

clear

************USAIPO 1977-0972*******

infile using Dictionaries\aipo1977-0972.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0972"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0972.dta, replace

***************

clear

*************USAIPO 1977-0971*******

infile using Dictionaries\aipo1977-0971.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0971"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0971.dta, replace

*****************************************

clear

*************USAIPO 1977-0970*****

infile using Dictionaries\aipo1977-0970.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0970"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0970.dta, replace


*****************************

clear

************USAIPO 1977-0969****

infile using Dictionaries\aipo1977-0969.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0969"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0969.dta, replace


************

clear


****USAIPO1977-0968****

*Read in dictionary file for USAIPO1977-0968; February 18, 1977 - February 21, 1977)
infile using Dictionaries\aipo1977-0968.dct

*The sample size in the codebook - 1,589 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1977-0968"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*Normally, we would compare the age frequencies by category to either the age distribution chart or the age deciles variables (depending on which version the codebook uses). However, this codebook provides neither, nor does it provide a frequency table in the back of the codebook, so we cannot double-check the variable by identifying frequencies by column and then comparing against the table.

*Perform basic check: tabulate the variable to ensure that there are no unexpected observations (i.e., outside expected age categories)
tab age_orig

*There are no unexpected observations

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1977-0968.dta, replace

clear


***********USAIPO 1977-0967*******

infile using Dictionaries\aipo1977-0967.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0967"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0967.dta, replace

***********************

clear

************USAIPO 1977-0966******

infile using Dictionaries\aipo1977-0966.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0966"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0966.dta, replace


****************************

clear

************USAIPO 1977-0965******

infile using Dictionaries\aipo1977-0965.dct

**correct N read in

*Create a variable for survey code
gen svy = "1977-0965"

*Create a variable for survey year
gen svy_year = 1977

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1977-0965.dta, replace

*******************************

clear

****USAIPO 1976-0964*******

infile using Dictionaries\aipo1976-0964.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0964"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0964.dta, replace


***********************

clear

******************USAIPO1976-0963*****

infile using Dictionaries\aipo1976-0963.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0963"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0963.dta, replace

*******************************

clear

*********USAIPO 1976-0962*****

infile using Dictionaries\aipo1976-0962.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0962"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0962.dta, replace


*******************************

clear

************USAIPO 1976-0961*****

infile using Dictionaries\aipo1976-0961.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0961"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0961.dta, replace

*************************

clear

*********USAIPO 1976-0960*****

infile using Dictionaries\aipo1976-0960.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0960"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0960.dta, replace

********************

clear


******USAIPO 1976-0958****

infile using Dictionaries\aipo1976-0958.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0958"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0958.dta, replace


*************************

clear

***********USAIPO 1976-0957******

infile using Dictionaries\aipo1976-0957.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0957"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0957.dta, replace

*******************************

clear

************USAIPO 1976-0956******

infile using Dictionaries\aipo1976-0956.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0956"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0956.dta, replace

*******************************

clear

****************USAIPO1976-0955*****


infile using Dictionaries\aipo1976-0955.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0955"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0955.dta, replace

************************

clear

***********USAIPO 1976-0954*******

infile using Dictionaries\aipo1976-0954.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0954"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0954.dta, replace

********************

clear

*******************USAIPO 1976-0953****

infile using Dictionaries\aipo1976-0953.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0953"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0953.dta, replace


*************************

clear

*********USAIPO 1976-0952*****

infile using Dictionaries\aipo1976-0952.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0952"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0952.dta, replace


*****************************

clear

********USAIPO 1976-0951*****

infile using Dictionaries\aipo1976-0951.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0951"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "April-May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

**With the exception of one state -- Hawaii -- the frequency distribution displayed next to the variable in the codebook matches the tabulated variable. As there is no frequency table in the back of the codebook, we cannot double-check the variable by identifying frequencies by column and then comparing against the table.

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0951.dta, replace

**************************************

clear

*************USAIPO 1976-0950******

infile using Dictionaries\aipo1976-0950.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0950"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0950.dta, replace

****************************

clear

*******USAIPO 1976-0949*****

infile using Dictionaries\aipo1976-0949.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0949"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0949.dta, replace

*************************

clear

**************USAIPO 1976-0948****

infile using Dictionaries\aipo1976-0948.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0948"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0948.dta, replace

*************************************

clear

***************USAIPO 1976-0947******


infile using Dictionaries\aipo1976-0947.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0947"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0947.dta, replace

**********************************

clear

*************USAIPO 1976-0946***************

infile using Dictionaries\aipo1976-0946.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0946"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "February-March"

*Begin harmonization of variables

tab wgt

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0946.dta, replace

***************************

clear

************USAIPO 1976-0945****

infile using Dictionaries\aipo1976-0945.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0945"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "January-February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution is similar
*to other surveys

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0945.dta, replace

*******************************

clear

*************USAIPO 1976-0944*****

infile using Dictionaries\aipo1976-0944.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0944"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0944.dta, replace

************************************

clear

******USAIPO 1976-0943****

infile using Dictionaries\aipo1976-0943.dct

**correct N read in

*Create a variable for survey code
gen svy = "1976-0943"

*Create a variable for survey year
gen svy_year = 1976

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig
*frequency and codes match*

gen raceSex = raceSex_orig

*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1976-0943.dta, replace

***************************************************

clear

****USAIPO1975-0942***

infile using Dictionaries\aipo1975-0942.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0942"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0942.dta, replace

*************************

clear

**************USAIPO1975-0941*****

infile using Dictionaries\aipo1975-0941.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0941"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0941.dta, replace


************************

clear

**************USAIPO1975-0940****

infile using Dictionaries\aipo1975-0940.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0940"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0940.dta, replace

************************

clear

**********USAIPO 1975-0939****

infile using Dictionaries\aipo1975-0939.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0939"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "October-November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

*tab sex_orig
*frequency matches 
*gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
*tab race_orig
*frequency matches
*Generate new var
*gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches*

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0939.dta, replace

******************************

clear

*********USAIPO 1975-0938***

infile using Dictionaries\aipo1975-0938.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0938"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but distribution makes sense***

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0938.dta, replace

*********************

clear

******USAIPO1975-0937****

infile using Dictionaries\aipo1975-0937.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0937"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*1 MALE 2 FEMALE harmonization 

tab sex_orig
*frequency matches 
gen sex = sex_orig


*1 WHITE 2 BLACK 3 OTHER harmonization for race

*Check var
tab race_orig
*frequency matches
*Generate new var
gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook; dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0937.dta, replace


********************************

clear

***********USAIPO1975-0936*****

infile using Dictionaries\aipo1975-0936.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0936"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches***

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0936.dta, replace


*******************************************

clear

*****USAIPO 1975-0935*******

infile using Dictionaries\aipo1975-0935.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0935"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches***

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0935.dta, replace

************************
clear

*************USAIPO 1975-0934****

infile using Dictionaries\aipo1975-0934.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0934"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches***

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0934.dta, replace

***********************

clear

*********USAIPO 1975-0933****

infile using Dictionaries\aipo1975-0933.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0933"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

tab raceSex_orig

*frequency and codes match
gen raceSex = raceSex_orig

tab race_orig

*frequency and codes match*

gen race = race_orig


tab sex_orig

*frequency and codes match*

gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook; dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0933.dta, replace


*************************

clear

**********USAIPO1975-0932****


infile using Dictionaries\aipo1975-0932.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0932"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

tab race_orig 

*matches

gen race = race_orig

tab sex_orig

*matches

gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0932.dta, replace

***********************

clear

*******************USAIPO 1975-0931****

infile using Dictionaries\aipo1975-0931.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0931"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0931.dta, replace

***************************

clear

************USAIPO 1975-0930*****

infile using Dictionaries\aipo1975-0930.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0930"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "May-June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0930.dta, replace

***********************

clear

*********USAIPO 1975-0929****

infile using Dictionaries\aipo1975-0929.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0929"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

tab race_orig 

*matches

gen race = race_orig

tab sex_orig

*matches

gen sex = sex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0929.dta, replace


****************************

clear

***********USAIPO 1975-0928***

infile using Dictionaries\aipo1975-0928.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0928"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0928.dta, replace

*******************************

clear

*************USAIPO 1975-0927******

infile using Dictionaries\aipo1975-0927.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0927"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0927.dta, replace

*******************************8

clear

************USAIPO 1975-0926*****

infile using Dictionaries\aipo1975-0926.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0926"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0926.dta, replace

**************************************

clear

**********USAIPO 1975-0925******

infile using Dictionaries\aipo1975-0925.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0925"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0925.dta, replace

*********************************

clear

**********USAIPO 1975-0924*****

infile using Dictionaries\aipo1975-0924.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0924"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "February-March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0924.dta, replace

****************

clear

************USAIPO 1975-0923****

infile using Dictionaries\aipo1975-0923.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0923"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0923.dta, replace


***************************

clear

***************USAIPO 1975-0922****

infile using Dictionaries\aipo1975-0922.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0922"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "January-February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0922.dta, replace


**************************8

clear

***********USAIPO 1975-0921*****

infile using Dictionaries\aipo1975-0921.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1975-0921"

*Create a variable for survey year
gen svy_year = 1975

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"

tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"

*Replace values
*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but distribution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1975-0921.dta, replace


********************************************
clear

****USAIPO1974-0920***********

infile using Dictionaries\aipo1974-0920.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0920"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*With the exception of one age category -- 21-29 -- the frequency distribution displayed next to the variable in the codebook matches the tabulated variable. As there is no frequency table in the back of the codebook, we cannot double-check the variable by identifying frequencies by column and then comparing against the table. However, it appears that the coded observations are correct, as the total N for the variable, as coded, equals the sample size of the dataset, whereas the total N for the variable, based on the codebook, is 100 less than the sample size.

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0920.dta, replace

*************************

clear

**************USAIPO 1974-0919****

infile using Dictionaries\aipo1974-0919.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0919"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency off by 1 for the 18-20 year olds; 95 in data and
*94 in codebook

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0919.dta, replace

***********************************

clear

***************USAIPO 1974-0918******

infile using Dictionaries\aipo1974-0918.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0918"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0918.dta, replace


***********************************

clear

*************USAIPO 1974-0917*****

infile using Dictionaries\aipo1974-0917.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0917"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0917.dta, replace

********************************

clear

*************USAIPO 1974-0916*****

infile using Dictionaries\aipo1974-0916.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0916"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85

tab state

replace state = . if state == 88

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but the distibution makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0916.dta, replace

***************************

clear

***************USAIPO 1974-0915*****

infile using Dictionaries\aipo1974-0915.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0915"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0915.dta, replace

*******************************

clear

************USAIPO 1974-0914*****

infile using Dictionaries\aipo1974-0914.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0914"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0914.dta, replace


***********************************8

clear

************USAIPO 1974-0913*****

infile using Dictionaries\aipo1974-0913.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0913"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0913.dta, replace

************************************

clear

************USAIPO 1974-0912******

infile using Dictionaries\aipo1974-0912.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0912"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0912.dta, replace

*************************

clear

******USAIPO 1974-0911****

infile using Dictionaries\aipo1974-0911.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0911"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0911.dta, replace


*****************************

clear

***********USAIPO 1974-0910*****

infile using Dictionaries\aipo1974-0910.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0910"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "June-July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0910.dta, replace

****************************

clear

**************USAIPO 1974-0908*****

infile using Dictionaries\aipo1974-0908.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0908"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0908.dta, replace

************************

clear

***********USAIPO 1974-0906******

infile using Dictionaries\aipo1974-0906.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0906"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "May-June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0906.dta, replace

********************************

clear

************USAIPO 1974-0903******

infile using Dictionaries\aipo1974-0903.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0903"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0903.dta, replace

***************************

clear

************USAIPO 1974-0902*****

infile using Dictionaries\aipo1974-0902.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0902"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0902.dta, replace

*********************************

clear

**************USAIPO 1974-0900-0901******

infile using Dictionaries\aipo1974-0900-0901.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0900-0901"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0900-0901.dta, replace

************************************

clear

************USAIPO 1974-0899******

infile using Dictionaries\aipo1974-0899.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0899"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0899.dta, replace

**********************************

clear

************USAIPO 1974-0897*****

infile using Dictionaries\aipo1974-0897.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0897"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "March-April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

tab sex_orig
gen sex = sex_orig

tab race_orig
gen race = race_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0897.dta, replace

*******************************

clear


****USAIPO1974-0894-0895****

*Read in dictionary file for USAIPO1974-0894-0895; March 8, 1974 - March 18, 1974)
infile using Dictionaries\aipo1974-0894-0895.dct

*The sample size in the codebook - 1,582 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1974-0894-0895"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*N/A: This variable is not available in this file


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1974-0894-0895.dta, replace

clear


***************USAIPO 1974-0892-0893****

infile using Dictionaries\aipo1974-0892-0893.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0892-0893"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "February-March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig

tab race_orig
gen race = race_orig

tab sex_orig
gen sex = sex_orig

*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency not in codebook but dist makes sense

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0892-0893.dta, replace

**********************************

clear

*************USAIPO 1974-0890-0891*****

infile using Dictionaries\aipo1974-0890-0891.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0890-0891"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0890-0891.dta, replace


************************************

clear

***************USAIPO 1974-0889*****

infile using Dictionaries\aipo1974-0889.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0889"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0889.dta, replace

*******************************

clear

*************USAIPO 1974-0888***

infile using Dictionaries\aipo1974-0888.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0888"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0888.dta, replace

*******************************

clear

**************USAIPO 1974-0886******

infile using Dictionaries\aipo1974-0886.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1974-0886"

*Create a variable for survey year
gen svy_year = 1974

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1974-0886.dta, replace

*************************************************

clear


*******USAIPO1973-0885*********

infile using Dictionaries\aipo1973-0885.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0885"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0885.dta, replace

*************************************

clear

************USAIPO 1973-0884*****

infile using Dictionaries\aipo1973-0884.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0884"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "November-December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0884.dta, replace

***************************************

clear

************USAIPO 1973-0883*******

infile using Dictionaries\aipo1973-0883.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0883"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0883.dta, replace

***************************

clear

****************USAIPO 1973-0882*****

infile using Dictionaries\aipo1973-0882.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0882"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0882.dta, replace

******************************************

clear

******************USAIPO 1973-0881******

infile using Dictionaries\aipo1973-0881.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0881"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0881.dta, replace

*********************************

clear

****************USAIPO 1973-0880******

infile using Dictionaries\aipo1973-0880.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0880"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0880.dta, replace

*************************************

clear

*****************USAIPO 1973-0878*******

infile using Dictionaries\aipo1973-0878.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0878"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0878.dta, replace


****************************

clear

*************USAIPO 1973-0877*******************

infile using Dictionaries\aipo1973-0877.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0877"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0877.dta, replace

********************************

clear

*************USAIPO1973-0876***************

infile using Dictionaries\aipo1973-0876.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0876"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0876.dta, replace

*******************************

clear

***************USAIPO1973-0875*************

infile using Dictionaries\aipo1973-0875.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0875"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0875.dta, replace

****************************

clear

***************USAIPO1973-0874************

infile using Dictionaries\aipo1973-0874.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0874"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0874.dta, replace

************************************

clear

************USAIPO1973-0873******

infile using Dictionaries\aipo1973-0873.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0873"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0873.dta, replace

*****************************************

clear

*************USAIPO1973-0872**********

infile using Dictionaries\aipo1973-0872.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0872"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0872.dta, replace

***************************************

clear

***************USAIPO1973-0871**********

infile using Dictionaries\aipo1973-0871.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0871"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0871.dta, replace

*******************************

clear

**************USAIPO1973-0870************

infile using Dictionaries\aipo1973-0870.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0870"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0870.dta, replace

************************************

clear

*****************USAIPO1973-0869*******

infile using Dictionaries\aipo1973-0869.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0869"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0869.dta, replace


****************************

clear

*************USAIPO1973-0868********

infile using Dictionaries\aipo1973-0868.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0868"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0868.dta, replace

**********************************

clear

************USAIPO1973-0867*********

infile using Dictionaries\aipo1973-0867.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0867"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "March-April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0867.dta, replace

*******************************

clear

****USAIPO1973-0864****

clear

*Read in dictionary file for USAIPO1973-0864; February 16, 1973 - February 19, 1973
infile using Dictionaries\aipo1973-0864.dct

*The sample size in the codebook - 1,517 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1973-0864"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY

*Harmonization Plan: Synchronization of variable name for consistency with other surveys and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. In the "Finalize Dataset" section, set values to missing where the observation is set to "NO CODE OR NO DATA," and define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT

*Harmonization Plan: Synchronization of variable name for consistency with other surveys and recoding of values for consistency across surveys. In the "Finalize Dataset" section, set values to missing where the observation is set to "NO CODE OR NO DATA," and define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Race and gender are in one variable for this survey

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT

*Harmonization Plan: Synchronization of variable name for consistency with other surveys. In the "Finalize Dataset" section, set values to missing where the observation is set to "NO CODE OR NO DATA."

*Check the variable - tab each age category and compare with the age distribution table in the codebook
*18-20 years
tab age_orig if age_orig>17 & age_orig<21
*21-29 years
tab age_orig if age_orig>20 & age_orig<30
*30-39 years
tab age_orig if age_orig>29 & age_orig<40
*40-49 years
tab age_orig if age_orig>39 & age_orig<50
*50-59 years
tab age_orig if age_orig>49 & age_orig<60
*60-69 years
tab age_orig if age_orig>59 & age_orig<70
*70-79 years
tab age_orig if age_orig>69 & age_orig<80
*80-89 years
tab age_orig if age_orig>79 & age_orig<90
*90 years and over
tab age_orig if age_orig>=90
*NO CODE OR NO DATA
tab age_orig if age_orig == 0

*The frequency distribution for this variable matches that in the codebook

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN

*Harmonization Plan: Synchronization of variable name for consistency with other surveys and recoding of values for consistency across surveys. In the "Finalize Dataset" section, set values to missing where the observation is set to "NO CODE OR NO DATA," and define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


*LEVEL OF PERSONAL FEDERAL INCOME TAX

*Harmonization Plan: Synchronization of variable name for consistency with other surveys and recoding of values for consistency across surveys. In "Finalize Dataset" section, set values to missing where the observation is set to "NO CODE OR NO DATA," and define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab fedIncomeTax_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen fedIncomeTax = fedIncomeTax_orig


*WEIGHT

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1973-0864.dta, replace

*******************************

clear

*************USAIPO1973-0863********

infile using Dictionaries\aipo1973-0863.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1973-0863"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1973-0863.dta, replace

*********************************************

clear


****USAIPO1973-0862****

*Read in dictionary file for USAIPO1973-0862; January 12, 1973 - January 15, 1973)
infile using Dictionaries\aipo1973-0862.dct

*The sample size in the codebook - 1,549 - matches the number of observations read into Stata

*Create a variable for survey code
gen svy = "1973-0862"

*Create a variable for survey year
gen svy_year = 1973

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables


*PARTY ID IN POLITICS TODAY (poliPartyID)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. For files in which the main party question is combined with a second question (i.e., coded in a single variable) that asks whether Independents lean more toward the Democratic Party or the Republican Party, all Independent responses -- such as Independent, lean toward the Democratic Party and Independent, lean toward the Republican Party -- will be coded in a single category of Independents. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY." Note that the standard form of question on which the variable is based reads, "In politics, as of today, do you consider yourself a Republican, Democrat, or Independent?"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab poliPartyID_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen poliPartyID = poliPartyID_orig


*RACE AND GENDER OF THE RESPONDENT (raceSex)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN" 7 "NON-WHITE MAN" 8 "NON-WHITE WOMAN"

*Check the variable - tab it and compare with frequency distribution in the codebook
tab raceSex_orig

*The frequency distribution for this variable matches that in the codebook

*Values are coded consistently with harmonization plan, so no need to recode

*Generate a new variable to ensure synchronization of variable name across surveys
gen raceSex = raceSex_orig


*AGE OF THE RESPONDENT (age)

*Harmonization Plan: Survey-by-survey synchronization of variable name. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA"

*Check the variable - tab each age category and compare with the age distribution table in the codebook
*18-20 years
tab age_orig if age_orig>17 & age_orig<21
*21-29 years
tab age_orig if age_orig>20 & age_orig<30
*30-39 years
tab age_orig if age_orig>29 & age_orig<40
*40-49 years
tab age_orig if age_orig>39 & age_orig<50
*50-59 years
tab age_orig if age_orig>49 & age_orig<60
*60-69 years
tab age_orig if age_orig>59 & age_orig<70
*70-79 years
tab age_orig if age_orig>69 & age_orig<80
*80-89 years
tab age_orig if age_orig>79 & age_orig<90
*90 years and over
tab age_orig if age_orig>=90
*NO CODE OR NO DATA
tab age_orig if age_orig == 0

*With the exception of one age category -- 18-20 -- the frequency distribution displayed next to the variable in the codebook matches the tabulated variable. There are 85 observations in the 18-20 category in the tabulated data but 86 observations in the category, according to the codebook. Perhaps an unexpected observation is being tallied with the 18-20 year olds in the codebook.

*Tabulate the variable to ensure that there are no unexpected observations (i.e., outside expected age categories)
tab age_orig

*There is a 17 year old in the dataset. However, as there is no frequency table in the back of the codebook, we cannot double-check the variable by identifying frequencies by column and then comparing against the table. The 17 year old may have been counted erroneously in the 18-20 category in the codebook, which would explain the extra observation displayed therein. Seventeen year olds have cropped up in other Gallup surveys used for this dataset, and we have retained them, so we will do the same here.

*Generate a new variable to ensure synchronization of variable name across surveys
gen age = age_orig


*STATE THE RESPONDENT LIVES IN (state)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA."

*Check the variable - tab it and compare with frequency distribution in the codebook
tab state_orig

*The frequency distribution for this variable matches that in the codebook

*Values are not coded consistently with harmonization plan; recode variable

*Generate a new variable to ensure synchronization of variable name across surveys
gen state = state_orig

*Replace values
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64


*LEVEL OF PERSONAL FEDERAL INCOME TAX (fedIncomeTax)

*Harmonization Plan: Survey-by-survey synchronization of variable name and recoding of values for consistency across surveys. After appending files, we will set values to missing where the observation is set to "NO CODE OR NO DATA," and we will define value labels and assign to variable. Label will be defined as: 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION." Note that this variable is included only in USAIPO1973-0864 (February 16, 1973 - February 19, 1973) for this batch of files.

*N/A: This variable is not available in this file


*WEIGHT (wgt)

*Harmonization Plan: Check the variable to ensure that frequencies match the codebook, but no additional adjustments, e.g., variable name synchronization, recoding, labeling, etc., are required.

*Check the variable - tab it and compare with frequency distribution in the codebook
tab wgt

*The frequency distribution for this variable matches that in the codebook


*Save the data
saveold FormattedData\1973-0862.dta, replace

clear


****USAIPO1972-0861**************

infile using Dictionaries\aipo1972-0861.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0861"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0861.dta, replace

******************************

clear

***********USAIPO1972-0860*****

infile using Dictionaries\aipo1972-0860.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0860"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0860.dta, replace

********************

clear

**********USAIPO1972-0859*******


infile using Dictionaries\aipo1972-0859.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0859"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "October"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0859.dta, replace

*****************************************

clear

*************USAIPO1972-0858******

infile using Dictionaries\aipo1972-0858.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0858"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "September"

*Begin harmonization of variables

tab wgt

**weight has a 0 code in this file with a frequency of 7

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0858.dta, replace

*****************************

clear

****************USAIPO1972-0857*******

infile using Dictionaries\aipo1972-0857.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0857"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0857.dta, replace

***************************

clear

***********USAIPO1972-0856*******

infile using Dictionaries\aipo1972-0856.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0856"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0856.dta, replace

*************************************

clear

*************USAIPO1972-0855*****

infile using Dictionaries\aipo1972-0855.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0855"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0855.dta, replace

********************************

clear

*********USAIPO1972-0854********

infile using Dictionaries\aipo1972-0854.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0854"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0854.dta, replace

***********************************

clear

***********USAIPO1972-0853**********

infile using Dictionaries\aipo1972-0853.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0853"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0853.dta, replace

***************************************

clear

****************USAIPO1972-0852**********

infile using Dictionaries\aipo1972-0852.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0852"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0852.dta, replace

**********************************

clear

**************USAIPO1972-0851*********

infile using Dictionaries\aipo1972-0851.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0851"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "April-May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0851.dta, replace

********************************

clear

************USAIPO1972-0850*********

infile using Dictionaries\aipo1972-0850.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0850"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0850.dta, replace

**********************************

clear

*************USAIPO1972-0849*********

infile using Dictionaries\aipo1972-0849.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0849"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0849.dta, replace

******************************************

clear

************USAIPO1972-0847************

infile using Dictionaries\aipo1972-0847.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0847"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0847.dta, replace

***********************************

clear

********USAIPO1972-0846**********

infile using Dictionaries\aipo1972-0846.dct

***File reads in only half the observations****

*Create a variable for survey code
gen svy = "1972-0846"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches, but there is a 17 year old in this dataset

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0846.dta, replace

*******************************************

clear

*********USAIPO1972-0844********

infile using Dictionaries\aipo1972-0844.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0844"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0844.dta, replace

**************************************

clear

***********USAIPO1972-0843************

infile using Dictionaries\aipo1972-0843.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1972-0843"

*Create a variable for survey year
gen svy_year = 1972

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1972-0843.dta, replace

*****************************

clear

*******USAIPO1971-0842*******

infile using Dictionaries\aipo1971-0842.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0842"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "December"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0842.dta, replace


****************************************

clear

*************USAIPO1971-0840********

infile using Dictionaries\aipo1971-0840.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0840"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0840.dta, replace

*********************************

clear

***********USAIPO1971-0839******

infile using Dictionaries\aipo1971-0839.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0839"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "October-November"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*there is an 11 year old in the dataset***

*With the exception of one age category -- 18-20 -- the frequency distribution displayed next to the variable in the codebook matches the tabulated variable. As there is no frequency table in the back of the codebook, we cannot double-check the variable by identifying frequencies by column and then comparing against the table. Note that there is one fewer observation in the 18-20 category in the tabulated variable than in the codebook, but given the 11 year old in the dataset, perhaps the extra observation shown in the codebook for the 18-20 category is picking up this observation, which was likely coded incorrectly.

gen age = age_orig

*replace value for 11 year old
replace age = . if age_orig == 11


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0839.dta, replace

*********************************

clear

************USAIPO1971-0836**********

infile using Dictionaries\aipo1971-0836.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0836"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0836.dta, replace

****************************************

clear

**************USAIPO1971-0835*********

infile using Dictionaries\aipo1971-0835.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0835"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "August"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0835.dta, replace

***************************************

clear

************USAIPO1971-0834*********

infile using Dictionaries\aipo1971-0834.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0834"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "July"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0834.dta, replace

*******************************

clear

************USAIPO1971-0833********

infile using Dictionaries\aipo1971-0833.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0833"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

*Note that the front page of the codebook indicates that weight is in column 19 (card two), but that is actually the "WEIGHT. TRENDS FACTOR" variable. For consistency with other datasets, we use weight in column 18 (card two), which appears to be the variable for the "times-at-home" weighting procedure.

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

replace poliPartyID = . if poliPartyID == 5

*Save the data
saveold FormattedData\1971-0833.dta, replace

*******************************

clear

*************USAIPO1971-0831********

infile using Dictionaries\aipo1971-0831.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0831"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "June"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding
*Texas is 101 in the codebook, but 100 is read in the data

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0831.dta, replace

*********************************

clear

**************USAIPO1971-0830******

infile using Dictionaries\aipo1971-0830.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0830"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "May"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0830.dta, replace

**********************************

clear

**************USAIPO1971-0828******************

infile using Dictionaries\aipo1971-0828.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0828"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0828.dta, replace

*********************************

clear

*************USAIPO1971-0826********

infile using Dictionaries\aipo1971-0826.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0826"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "April"

*Begin harmonization of variables

tab wgt

*weight has a value of 0

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

replace poliPartyID = . if poliPartyID == 5

*Save the data
saveold FormattedData\1971-0826.dta, replace

********************************************

clear

***********USAIPO1971-0825*********

infile using Dictionaries\aipo1971-0825.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0825"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "March"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0825.dta, replace

********************************

clear

*************USAIPO1971-0824********

infile using Dictionaries\aipo1971-0824.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0824"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "February"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0824.dta, replace

******************************************

clear

*************USAIPO1971-0821********

infile using Dictionaries\aipo1971-0821.dct

**correct N read in**

*Create a variable for survey code
gen svy = "1971-0821"

*Create a variable for survey year
gen svy_year = 1971

*Create a variable for survey month
gen svy_month = "January"

*Begin harmonization of variables

tab wgt

**harmonization for raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 
*4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
tab raceSex_orig

*frequency and codes match*

gen raceSex = raceSex_orig


*STATE THE RESPONDENT LIVES IN

*Check the variable 
tab state_orig

*Frequencies line up, but needs some recoding

gen state = state_orig

*Harmonization Codes

*11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 
*15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 
*23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" *
*27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 
*41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA"
* 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 
*52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 
*56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 
*81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 
*61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 
*66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 
*73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA" 0 "NO CODE OR NO DATA"


*Replace values
replace state = 81 if state_orig == 61
replace state = 82 if state_orig == 62
replace state = 83 if state_orig == 63
replace state = 84 if state_orig == 64
replace state = 61 if state_orig == 71
replace state = 62 if state_orig == 72
replace state = 63 if state_orig == 73
replace state = 64 if state_orig == 74
replace state = 65 if state_orig == 75
replace state = 66 if state_orig == 76
replace state = 67 if state_orig == 77
replace state = 68 if state_orig == 78
replace state = 71 if state_orig == 81
replace state = 72 if state_orig == 82
replace state = 73 if state_orig == 83
replace state = 74 if state_orig == 84
replace state = 75 if state_orig == 85


tab state

*AGE OF THE RESPONDENT

*Check the variable
tab age_orig

*frequency matches

gen age = age_orig


*PARTY ID IN POLITICS TODAY

*Check the variable 
tab poliPartyID_orig

**1 REPUBLICAN 2 DEMOCRAT 3 INDEPENDENT 4 OTHER PARTY
*frequency and coding matches harmonization plan

gen poliPartyID = poliPartyID_orig

*Save the data
saveold FormattedData\1971-0821.dta, replace

********************************

clear

**********************************

****Appending the files****

use FormattedData\1980-1166.dta
append using FormattedData\1980-1165.dta
append using FormattedData\1980-1164.dta
append using FormattedData\1980-1163.dta
append using FormattedData\1980-1162.dta
append using FormattedData\1980-1161.dta
append using FormattedData\1980-1160.dta
append using FormattedData\1980-1159.dta
append using FormattedData\1980-1158.dta
append using FormattedData\1980-1157.dta
append using FormattedData\1980-1156.dta
append using FormattedData\1980-1155.dta
append using FormattedData\1980-1154.dta
append using FormattedData\1980-1153.dta
append using FormattedData\1980-1151.dta
append using FormattedData\1980-1150.dta
append using FormattedData\1980-1149.dta
append using FormattedData\1980-1148.dta
append using FormattedData\1980-1147.dta
append using FormattedData\1980-1146.dta
append using FormattedData\1979-1145.dta
append using FormattedData\1979-1144.dta
append using FormattedData\1979-1143.dta
append using FormattedData\1979-1142.dta
append using FormattedData\1979-1141.dta
append using FormattedData\1979-1140.dta
append using FormattedData\1979-1139.dta
append using FormattedData\1979-1138.dta
append using FormattedData\1979-1137.dta
append using FormattedData\1979-1136.dta
append using FormattedData\1979-1135.dta
append using FormattedData\1979-1133.dta
append using FormattedData\1979-1132.dta
append using FormattedData\1979-1131.dta
append using FormattedData\1979-1130.dta
append using FormattedData\1979-1129.dta
append using FormattedData\1979-1128.dta
append using FormattedData\1979-1127.dta
append using FormattedData\1979-1125.dta
append using FormattedData\1979-1124.dta
append using FormattedData\1979-1123.dta
append using FormattedData\1979-1122.dta
append using FormattedData\1979-1120.dta
append using FormattedData\1979-1119.dta
append using FormattedData\1978-1117.dta
append using FormattedData\1978-1116.dta
append using FormattedData\1978-1115.dta
append using FormattedData\1978-1114.dta
append using FormattedData\1978-1113.dta
append using FormattedData\1978-1112.dta
append using FormattedData\1978-1111.dta
append using FormattedData\1978-1110.dta
append using FormattedData\1978-1109.dta
append using FormattedData\1978-1108.dta
append using FormattedData\1978-1105.dta
append using FormattedData\1978-1104.dta
append using FormattedData\1978-1103.dta
append using FormattedData\1978-1102.dta
append using FormattedData\1978-1101.dta
append using FormattedData\1978-0999.dta
append using FormattedData\1978-0998.dta
append using FormattedData\1978-0997.dta
append using FormattedData\1978-0996.dta
append using FormattedData\1978-0995.dta
append using FormattedData\1978-0994.dta
append using FormattedData\1978-0993.dta
append using FormattedData\1978-0992.dta
append using FormattedData\1978-0991.dta
append using FormattedData\1977-0990.dta
append using FormattedData\1977-0989.dta
append using FormattedData\1977-0988.dta
append using FormattedData\1977-0987.dta
append using FormattedData\1977-0986.dta
append using FormattedData\1977-0985.dta
append using FormattedData\1977-0984.dta
append using FormattedData\1977-0983.dta
append using FormattedData\1977-0982.dta
append using FormattedData\1977-0981.dta
append using FormattedData\1977-0980.dta
append using FormattedData\1977-0979.dta
append using FormattedData\1977-0978.dta
append using FormattedData\1977-0977.dta
append using FormattedData\1977-0976.dta
append using FormattedData\1977-0975.dta
append using FormattedData\1977-0974.dta
append using FormattedData\1977-0973.dta
append using FormattedData\1977-0972.dta
append using FormattedData\1977-0971.dta
append using FormattedData\1977-0970.dta
append using FormattedData\1977-0969.dta
append using FormattedData\1977-0968.dta
append using FormattedData\1977-0967.dta
append using FormattedData\1977-0966.dta
append using FormattedData\1977-0965.dta
append using FormattedData\1976-0964.dta
append using FormattedData\1976-0963.dta
append using FormattedData\1976-0962.dta
append using FormattedData\1976-0961.dta
append using FormattedData\1976-0960.dta
append using FormattedData\1976-0958.dta
append using FormattedData\1976-0957.dta
append using FormattedData\1976-0956.dta
append using FormattedData\1976-0955.dta
append using FormattedData\1976-0954.dta
append using FormattedData\1976-0953.dta
append using FormattedData\1976-0952.dta
append using FormattedData\1976-0951.dta
append using FormattedData\1976-0950.dta
append using FormattedData\1976-0949.dta
append using FormattedData\1976-0948.dta
append using FormattedData\1976-0947.dta
append using FormattedData\1976-0946.dta
append using FormattedData\1976-0945.dta
append using FormattedData\1976-0944.dta
append using FormattedData\1976-0943.dta
append using FormattedData\1975-0942.dta
append using FormattedData\1975-0941.dta
append using FormattedData\1975-0940.dta
append using FormattedData\1975-0939.dta
append using FormattedData\1975-0938.dta
append using FormattedData\1975-0937.dta
append using FormattedData\1975-0936.dta
append using FormattedData\1975-0935.dta
append using FormattedData\1975-0934.dta
append using FormattedData\1975-0933.dta
append using FormattedData\1975-0932.dta
append using FormattedData\1975-0931.dta
append using FormattedData\1975-0930.dta
append using FormattedData\1975-0929.dta
append using FormattedData\1975-0928.dta
append using FormattedData\1975-0927.dta
append using FormattedData\1975-0926.dta
append using FormattedData\1975-0925.dta
append using FormattedData\1975-0924.dta
append using FormattedData\1975-0923.dta
append using FormattedData\1975-0922.dta
append using FormattedData\1975-0921.dta
append using FormattedData\1974-0920.dta
append using FormattedData\1974-0919.dta
append using FormattedData\1974-0918.dta
append using FormattedData\1974-0917.dta
append using FormattedData\1974-0916.dta
append using FormattedData\1974-0915.dta
append using FormattedData\1974-0914.dta
append using FormattedData\1974-0913.dta
append using FormattedData\1974-0912.dta
append using FormattedData\1974-0911.dta
append using FormattedData\1974-0910.dta
append using FormattedData\1974-0908.dta
append using FormattedData\1974-0906.dta
append using FormattedData\1974-0903.dta
append using FormattedData\1974-0902.dta
append using FormattedData\1974-0900-0901.dta
append using FormattedData\1974-0899.dta
append using FormattedData\1974-0897.dta
append using FormattedData\1974-0894-0895.dta
append using FormattedData\1974-0892-0893.dta
append using FormattedData\1974-0890-0891.dta
append using FormattedData\1974-0889.dta
append using FormattedData\1974-0888.dta
append using FormattedData\1974-0886.dta
append using FormattedData\1973-0885.dta
append using FormattedData\1973-0884.dta
append using FormattedData\1973-0883.dta
append using FormattedData\1973-0882.dta
append using FormattedData\1973-0881.dta
append using FormattedData\1973-0880.dta
append using FormattedData\1973-0878.dta
append using FormattedData\1973-0877.dta
append using FormattedData\1973-0876.dta
append using FormattedData\1973-0875.dta
append using FormattedData\1973-0874.dta
append using FormattedData\1973-0873.dta
append using FormattedData\1973-0872.dta
append using FormattedData\1973-0871.dta
append using FormattedData\1973-0870.dta
append using FormattedData\1973-0869.dta
append using FormattedData\1973-0868.dta
append using FormattedData\1973-0867.dta
append using FormattedData\1973-0864.dta
append using FormattedData\1973-0863.dta
append using FormattedData\1973-0862.dta
append using FormattedData\1972-0861.dta
append using FormattedData\1972-0860.dta
append using FormattedData\1972-0859.dta
append using FormattedData\1972-0858.dta
append using FormattedData\1972-0857.dta
append using FormattedData\1972-0856.dta
append using FormattedData\1972-0855.dta
append using FormattedData\1972-0854.dta
append using FormattedData\1972-0853.dta
append using FormattedData\1972-0852.dta
append using FormattedData\1972-0851.dta
append using FormattedData\1972-0850.dta
append using FormattedData\1972-0849.dta
append using FormattedData\1972-0847.dta
append using FormattedData\1972-0846.dta
append using FormattedData\1972-0844.dta
append using FormattedData\1972-0843.dta
append using FormattedData\1971-0842.dta
append using FormattedData\1971-0840.dta
append using FormattedData\1971-0839.dta
append using FormattedData\1971-0836.dta
append using FormattedData\1971-0835.dta
append using FormattedData\1971-0834.dta
append using FormattedData\1971-0833.dta
append using FormattedData\1971-0831.dta
append using FormattedData\1971-0830.dta
append using FormattedData\1971-0828.dta
append using FormattedData\1971-0826.dta
append using FormattedData\1971-0825.dta
append using FormattedData\1971-0824.dta
append using FormattedData\1971-0821.dta


*Replace observations set to 0 ("NO CODE OR NO DATA") ***
replace raceSex = . if raceSex == 0 | raceSex == 9
replace race = . if race == 0 | race == 9 
replace sex = . if sex == 0 | sex == 9 
replace state = . if state == 0 | state == 9 
replace age = . if age == 0 | age == 9  
replace poliPartyID = . if poliPartyID == 0 | poliPartyID == 9
replace fedIncomeTax = . if fedIncomeTax == 0 | fedIncomeTax == 9


*****LABEL********

label variable svy "SURVEY CODE"


label variable svy_year "SURVEY YEAR"


label variable svy_month "SURVEY MONTH(S)"


label variable raceSex "RACE AND GENDER OF THE RESPONDENT"
label define lb_raceSex 1 "WHITE MAN" 2 "WHITE WOMAN" 3 "BLACK MAN" 4 "BLACK WOMAN" 5 "OTHER MAN" 6 "OTHER WOMAN"
label values raceSex lb_raceSex


label variable race "RACE OF THE RESPONDENT"
label define lb_race 1 "WHITE" 2 "BLACK" 3 "OTHER" 4 "NON-WHITE"
label values race lb_race


label variable sex "GENDER OF THE RESPONDENT"
label define lb_sex 1 "MALE" 2 "FEMALE"
label values sex lb_sex


label variable state "STATE THE RESPONDENT LIVES IN"
label define lb_state 11 "MAINE" 12 "NEW HAMPSHIRE" 13 "VERMONT" 14 "MASSACHUSETTS" 15 "RHODE ISLAND" 16 "CONNECTICUT" 21 "NEW YORK" 22 "NEW JERSEY" 23 "PENNSYLVANIA" 24 "MARYLAND" 25 "DELAWARE" 26 "WEST VIRGINIA" 27 "D.C." 31 "OHIO" 32 "MICHIGAN" 33 "INDIANA" 34 "ILLINOIS" 41 "WISCONSIN" 42 "MINNESOTA" 43 "IOWA" 44 "MISSOURI" 45 "NORTH DAKOTA" 46 "SOUTH DAKOTA" 47 "NEBRASKA" 48 "KANSAS" 51 "VIRGINIA" 52 "NORTH CAROLINA" 53 "SOUTH CAROLINA" 54 "GEORGIA" 55 "FLORIDA" 56 "KENTUCKY" 57 "TENNESSEE" 58 "ALABAMA" 59 "MISSISSIPPI" 81 "ARKANSAS" 82 "LOUISIANA" 83 "OKLAHOMA" 84 "TEXAS" 61 "MONTANA" 62 "ARIZONA" 63 "COLORADO" 64 "IDAHO" 65 "WYOMING" 66 "UTAH" 67 "NEVADA" 68 "NEW MEXICO" 71 "CALIFORNIA" 72 "OREGON" 73 "WASHINGTON" 74 "HAWAII" 75 "ALASKA"
label values state lb_state


label variable age "AGE OF THE RESPONDENT"


label variable poliPartyID "PARTY ID IN POLITICS TODAY"
label define lb_poliPartyID 1 "REPUBLICAN" 2 "DEMOCRAT" 3 "INDEPENDENT" 4 "OTHER PARTY" 
label values poliPartyID lb_poliPartyID


label variable fedIncomeTax "LEVEL OF PERSONAL FEDERAL INCOME TAX"
label define lb_fedIncomeTax 1 "TOO HIGH" 2 "ABOUT RIGHT" 3 "TOO LOW" 4 "DON'T KNOW/NO OPINION"
label values fedIncomeTax lb_fedIncomeTax

gen educ=.
replace educ = 1 if (educ_orig == 1 | educ_orig == 2 | educ_orig == 3) //None or Grade 1-8
replace educ = 4 if (educ_orig == 4) //HS Incomplete
replace educ = 5 if (educ_orig == 5) //HS Grad
replace educ = 6 if (educ_orig == 6) //Technical, Trade or Business
replace educ = 7 if (educ_orig == 7) //College, Uni., Incomplete
replace educ = 8 if (educ_orig == 8 | educ_orig==9) //College, Uni., Graduate
replace educ = 0 if (educ_orig == 0) //No Code
label variable educ "EDUCATION OF THE RESPONDENT"
label define lb_edu 1 "NONE, OR GRADES 1-8" 4 "HIGH SCHOOL INCOMPLETE (GRADES 9-11)" 5 "HIGH SCHOOL GRADUATE (GRADE 12)" 6 "TECHNICAL, TRADE, OR BUSINESS" 7 "COLLEGE, UNIVERSITY, INCOMPLETE" 8 "COLLEGE, UNIVERSITY, GRADUATE" 9 "POST_GRAD" 0 "NO CODE OR NO DATA"
label values educ lb_edu


**********************************************
*Check the data

*Count observations in the dataset
count


*Add numeric values to value labels to help check the data
numlabel, add

*Check each variable
bys svy: tab svy_year
bys svy: tab svy_month
bys svy: tab poliPartyID
bys svy: tab raceSex
bys svy: tab race
bys svy: tab sex
bys svy: tab age
bys svy: sum age
bys svy: tab state
bys svy: tab fedIncomeTax
bys svy: tab wgt

*Remove the numeric values from value labels
numlabel, remove

*Sort the data
sort svy

*Order the variables
order svy svy_year svy_month poliPartyID poliPartyID_orig raceSex raceSex_orig race race_orig sex sex_orig age age_orig state state_orig fedIncomeTax fedIncomeTax_orig wgt

*Compress data in memory
compress

*Rename educ so that I can merge it later
rename educ eduHarmonized

*Save the data
saveold PartyID_1971_1980.dta, replace

log close

exit, clear


